package xyz.lychee.lagfixer.libs.adventure.sound;

import java.util.Objects;
import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.adventure.internal.Internals;
import xyz.lychee.lagfixer.libs.adventure.key.Key;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

abstract class SoundStopImpl implements SoundStop {
   static final SoundStop ALL = new SoundStopImpl((Sound.Source)null) {
      public @Nullable Key sound() {
         return null;
      }
   };
   private final Sound.@Nullable Source source;

   SoundStopImpl(final Sound.@Nullable Source source) {
      this.source = source;
   }

   public Sound.@Nullable Source source() {
      return this.source;
   }

   public boolean equals(final @Nullable Object other) {
      if (this == other) {
         return true;
      } else if (!(other instanceof SoundStopImpl)) {
         return false;
      } else {
         SoundStopImpl that = (SoundStopImpl)other;
         return Objects.equals(this.sound(), that.sound()) && Objects.equals(this.source, that.source);
      }
   }

   public int hashCode() {
      int result = Objects.hashCode(this.sound());
      result = 31 * result + Objects.hashCode(this.source);
      return result;
   }

   public @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.of(ExaminableProperty.of("name", this.sound()), ExaminableProperty.of("source", this.source));
   }

   public String toString() {
      return Internals.toString(this);
   }
}
